VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsBpcaTglLbl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' == Caution for use! ==
' When you copy a class module in workbook, please perform it
' by Export & Import from Bpca_TglLbl_V41E.xls by all means.
' (The export file of the class module prepares in the distribution file.)
' If you perform it by Copy & Paste between code windows of VBE,
' Default-property (Item) does not work.


'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
'_/
'_/ [ clsBpcaTglLbl ] Ver4.1   (Excel2000 or later)
'_/
'_/   Flag type button only with good points of Toggle, Option and CheckBox.
'_/
'_/   AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.
'_/     [http://addinbox.sakura.ne.jp/Breakthrough_P-Ctrl_Arrays_Eng2.htm]
'_/     [Old Site  http://www.h3.dion.ne.jp/~sakatsu/Breakthrough_P-Ctrl_Arrays_Eng2.htm]
'_/
'_/     15 May 2004 Ver1.0  1st version(Japanese)
'_/     17 May 2004 Ver2.0
'_/     10 Jun 2004 Ver3.0
'_/     23 Jun 2004 Ver3.1
'_/     10 Mar 2005 Ver3.2
'_/     15 Apr 2011 Ver4.0
'_/     22 Jul 2014 Ver4.1
'_/
'_/     17 Aug 2014 Ver4.1  English version (1st version)
'_/
'_/  [clsBpcaTglLblCh] module is necessary together.
'_/  It works in x64.
'_/
'_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/


'-----[ Event definition ]-----------------------------------------------
Public Event Click(ByVal Index As Integer, _
                   ByVal Btn_Label As MSForms.Label, _
                   ByVal Btn_Value As Boolean)
                   
Public Event Change(ByVal Index As Integer, _
                    ByVal Btn_Label As MSForms.Label, _
                    ByVal Btn_Value As Boolean)

'------------------------------------------------------------------
Private clsTglLbl() As clsBpcaTglLblCh        'Child class
Private colLabel_TglLbl As Collection         'Storage collection of Controls
Private blnExclusive As Boolean               'Exclusive flag
Private blnRgst As Boolean                    'Registration flag

Private lngColor_ON As Long
Private lngColor_OFF As Long
Private blnColorChange As Boolean

'==============================================================
Private Sub Class_Initialize()
    Set colLabel_TglLbl = New Collection
    blnExclusive = False
    blnColorChange = False
    blnRgst = False
End Sub

'==============================================================
Private Sub Class_Terminate()
    Me.Clear
End Sub

'======== Property / Method definition =============================

'---( Add method )------------------------------------------------
'Add control to become FlagButton to collection.
Public Sub Add(ByVal lblNewLabel As MSForms.Label)
    If (blnRgst = False) Then
        colLabel_TglLbl.Add lblNewLabel  'Add to Collection
    Else
        'Because Rgst method is executed, I do not add it.
    End If
End Sub

'---( Rgst method )------------------------------------------------
Public Sub Rgst(ByVal Exclusive As Boolean)
Dim obj As Object
Dim i As Integer
    If (blnRgst = True) Then
        'Because Rgst method is executed, I do not handle it.
    ElseIf (colLabel_TglLbl.Count = 0) Then
        blnRgst = False
    Else
        ReDim clsTglLbl(1 To colLabel_TglLbl.Count)
        For i = 1 To colLabel_TglLbl.Count
            Set clsTglLbl(i) = New clsBpcaTglLblCh
            With clsTglLbl(i)
                .Rgst colLabel_TglLbl(i), i
                .Parent = Me
            End With
        Next i
        blnExclusive = Exclusive
        blnRgst = True
    End If
End Sub

'---( Clear method )-----------------------------
Public Sub Clear()
Dim i As Integer
    If (blnRgst = True) Then
        For i = 1 To colLabel_TglLbl.Count
            clsTglLbl(i).Clear
            Set clsTglLbl(i) = Nothing
        Next i
    End If
    Set colLabel_TglLbl = Nothing
    Erase clsTglLbl
    blnRgst = False
End Sub

'---( Init method )------------------------------------------------
Public Sub Init(ByVal lngOnColor As Long, _
                ByVal lngOffColor As Long, _
                ByVal vntInitValue As Variant)
Dim i As Integer
Dim j As Integer
Dim intArrayCount As Integer
Dim intMax As Integer
Dim intOnCount As Integer
Dim wkValue As Boolean

    If (blnRgst = False) Then
        'do nothing
    Else
        Select Case lngOnColor
          Case vbBlack To vbWhite
            'Normal color value(BBGGRR) &H00000000 to &H00ffffff
          Case vbScrollBars To vbInfoBackground
            'Sysytem color index &H80000000 to &H80000018
          Case Else
            'Color value is wrong
            Exit Sub
        End Select
        
        Select Case lngOffColor
          Case vbBlack To vbWhite
            'Normal color value(BBGGRR) &H00000000 to &H00ffffff
          Case vbScrollBars To vbInfoBackground
            'Sysytem color index &H80000000 to &H80000018
          Case Else
            'Color value is wrong
            Exit Sub
        End Select

        If (VarType(vntInitValue) = (vbArray + vbVariant)) Then
            'is Array (OK)
        Else
            Exit Sub    'is not Array (NG)
        End If
        
        blnColorChange = True
        lngColor_ON = lngOnColor
        lngColor_OFF = lngOffColor
        
        'Because it is setting of the initial state of the button,
        'the Change event does not fire it.
        'I set concave or convex directly..
        intArrayCount = UBound(vntInitValue) - LBound(vntInitValue) + 1
        If (colLabel_TglLbl.Count <= intArrayCount) Then
            intMax = colLabel_TglLbl.Count
        Else
            intMax = intArrayCount
        End If
        
        intOnCount = 0
        For i = 1 To intMax
            j = (i - 1) + LBound(vntInitValue)
            With colLabel_TglLbl(i)
                If (vntInitValue(j) = True) Then
                    intOnCount = intOnCount + 1
                    If (intOnCount > 1) And (blnExclusive = True) Then
                        'In the case of exclusion, ON-button is only one.
                        wkValue = False
                    Else
                        wkValue = True
                    End If
                Else
                    wkValue = False
                End If
                If (wkValue = True) Then
                    .SpecialEffect = fmSpecialEffectSunken
                    .BackColor = lngOnColor
                Else
                    .SpecialEffect = fmSpecialEffectRaised
                    .BackColor = lngOffColor
                End If
            End With
        Next i
    End If
End Sub

'---( OnValueSet method )------------------------------------------------
'When an argument is omit or 0, all buttons are turned on.
Public Sub OnValueSet(Optional ByVal intIndex As Integer = 0)
Dim i As Integer
    If (blnRgst = False) Then
        'do nothing
    Else
        If (intIndex = 0) Then
            If (blnExclusive = False) Then
                For i = 1 To colLabel_TglLbl.Count
                    Call prvSetValue(i, True)
                Next i
            Else
                'In the case of exclusion, it cannot do it in on with all buttons.
            End If
        Else
            Call prvSetValue(intIndex, True)
        End If
    End If
End Sub

'---( OffValueSet method )------------------------------------------------
'When an argument is omit or 0, all buttons are turned off.
Public Sub OffValueSet(Optional ByVal intIndex As Integer = 0)
Dim i As Integer
    If (blnRgst = False) Then
        'do nothing
    Else
        If (intIndex = 0) Then
            For i = 1 To colLabel_TglLbl.Count
                Call prvSetValue(i, False)
            Next i
        Else
            Call prvSetValue(intIndex, False)
        End If
    End If
End Sub

'---( GrpValue property )------------------------------------------------
Public Property Get GrpValue(Optional ByVal intIndex As Integer = 0) As Variant
Dim i As Integer
Dim BtnNo As Integer
Dim OnCnt As Integer
    
    If (blnRgst = False) Then
        GrpValue = CVErr(xlErrNA)   'Error (return #N/A)
    Else
        Select Case intIndex
          Case 0
            BtnNo = 0
            OnCnt = 0
            For i = 1 To colLabel_TglLbl.Count
                If (prvGetValue(i) = True) Then
                    BtnNo = i
                    OnCnt = OnCnt + 1
                End If
            Next i
            'In the case of exclusion, ON-button is only one.
            Select Case OnCnt
              Case 0
                'When all buttons are off, return zero.
                GrpValue = 0
              Case 1
                'When ON-button is one, return the button number.
                GrpValue = BtnNo
              Case Else
                'When ON-button are plural, return [ -1 ].
                GrpValue = -1
            End Select
          Case 1 To colLabel_TglLbl.Count
            GrpValue = prvGetValue(intIndex)
          Case Else
            'Index is out of a range.
            GrpValue = CVErr(xlErrNA)   'Error (return #N/A)
        End Select
    End If
End Property

'---( GrpEnabled property )------------------------------------------------
Public Property Let GrpEnabled(ByVal blnNewValue As Boolean)
Dim i As Integer
    If (blnRgst = False) Then
        'do nothing
    Else
        For i = 1 To colLabel_TglLbl.Count
            colLabel_TglLbl(i).Enabled = blnNewValue
        Next i
    End If
End Property

Public Property Get GrpEnabled() As Boolean
Dim i As Integer
    If (blnRgst = False) Then
        'do nothing
        GrpEnabled = False
    Else
        GrpEnabled = True
        For i = 1 To colLabel_TglLbl.Count
            If (colLabel_TglLbl(i).Enabled = False) Then
                'If one or more buttons are [Enabled=False], return False.
                GrpEnabled = False
            End If
        Next i
    End If
End Property

'---( Item property )------------------------------------------------
Public Property Get Item(ByVal intIndex As Integer) As MSForms.Label
Attribute Item.VB_UserMemId = 0
' Attribute Item.VB_UserMemId = 0

'(Note)
'The Item property becomes the Default property.
'The statement("Attribute Item.VB_UserMemId = 0") mentioned above is added
'to this part of the class module to assume it the Default property
'(you do not watch it from a code window).
'If you watch the export file of this class module, you can confirm it.

    If (blnRgst = True) And _
       (intIndex > 0) And (intIndex <= colLabel_TglLbl.Count) Then
        Set Item = colLabel_TglLbl(intIndex)
    Else
        Set Item = Nothing
    End If
End Property

'---( Count property )------------------------------------------------
Public Property Get Count() As Integer
    Count = colLabel_TglLbl.Count
End Property

'---( getIndex property )---------------------------------------------
'It returns a value of "Index" becoming necessary for each property from a control name.
'In the case of a non-registration name, it returns -1.
Public Property Get getIndex(ByVal CtrlName As String) As Integer
Dim i As Integer
    getIndex = -1
    If (blnRgst = True) Then
        For i = 1 To colLabel_TglLbl.Count
            If (colLabel_TglLbl(i).Name = CtrlName) Then
                getIndex = i
                Exit For
            End If
        Next i
    Else
    End If
End Property

'========[ Private Routine ]=================================

'---( Get and Set of Value )------------------------------------------------
Private Sub prvSetValue(ByVal intIndex As Integer, ByVal blnNewValue As Boolean)
Dim i As Integer
        
    If (blnNewValue = False) Then
        'The changes from on to off are effective regardless of
        'having exclusion or not. It fire Change event at the same time
        'to make a button the OFF state (Raise).
        Call prvValueChange(intIndex, fmSpecialEffectRaised)
    Else
        'Turn ON from OFF.
        If (blnExclusive = False) Then
            'Because there is no exclusion, it fire Change event at the
            'same time to make a button the ON state (Sunken).
            Call prvValueChange(intIndex, fmSpecialEffectSunken)
        Else
            'Because there is exclusion, Only an appointed button makes
            'an on state (Sunken) and all other buttons make the off state (Raise).
            For i = 1 To colLabel_TglLbl.Count
                If (i = intIndex) Then
                    'ON setting (Sunken) and fire of Change event
                    Call prvValueChange(i, fmSpecialEffectSunken)
                Else
                    'Change event occurs only by the control with the value change (turn OFF from ON).
                    Call prvValueChange(i, fmSpecialEffectRaised)
                End If
            Next i
        End If
    End If
End Sub

Private Function prvGetValue(ByVal intIndex As Integer) As Boolean
    If (colLabel_TglLbl(intIndex).SpecialEffect = fmSpecialEffectSunken) Then
        prvGetValue = True    'ON state (Sunken)
    Else
        prvGetValue = False   'OFF state (Raise)
    End If
End Function

'---( Turn "SpecialEffect"  and  Fire Change event )------------------------
'
'Update it only when present value and UpdValue are different,
'and Fire Change event.
'Change event fire for other Button in the group by exclusive control.

Private Sub prvValueChange(ByVal Btn_Index As Integer, _
                           ByVal UpdValue As MSForms.fmSpecialEffect)
    If (colLabel_TglLbl(Btn_Index).SpecialEffect <> UpdValue) Then
        With colLabel_TglLbl(Btn_Index)
            .SpecialEffect = UpdValue
            If (blnColorChange = True) Then
                If (.SpecialEffect = fmSpecialEffectSunken) Then
                    .BackColor = lngColor_ON
                Else
                    .BackColor = lngColor_OFF
                End If
            End If
        End With
        Call RaiseChange(Btn_Index)
    Else
        'do nothing (because a value does not change)
    End If
End Sub

'========[ Event Routine]=================================

Private Sub RaiseChange(ByVal Index As Integer)
    RaiseEvent Change(Index, colLabel_TglLbl(Index), prvGetValue(Index))
End Sub

'Event excitation method to be called from clsBpcaTglLblCh
'Fire Change event earlier than Click event.
Friend Sub RaiseClick(ByVal Index As Integer)

    'prvSetValue changes the value and fire Change event.
    If (prvGetValue(Index) = True) Then
        Call prvSetValue(Index, False)   'Turn OFF from ON
    Else
        Call prvSetValue(Index, True)    'Turn ON from OFF
    End If

    RaiseEvent Click(Index, colLabel_TglLbl(Index), prvGetValue(Index))
End Sub

'=====[AddinBox(K.Tsunoda) CopyRight(C) 2004 Allrights Reserved.]========

